services:
- docker:dind

stages:
  - compile
  - build
  - deploy

deploy-to-staging:
  image: "ruby:2.5.0"
  stage: deploy
  environment: staging
  script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY_STAGING" | base64 --decode)
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - ssh ubuntu@68.183.231.135 "cd ~/report-dashboard && git clean -f -d && git reset --hard origin/docker && git pull origin docker && bash deploy.sh staging"
  only:
    - docker
    
deploy-to-prod:
  image: "ruby:2.5.0"
  stage: deploy
  environment: production
  script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY" | base64 --decode)
    - mkdir -p ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - ssh ubuntu@206.189.33.84 "cd ~/report-dashboard && git clean -f -d && git reset --hard origin/master && git pull origin master && bash deploy.sh production"
  only:
    - master